#pragma once

#include "AbstractPainter.h"
#include <memory>

class DrawingContext;
class DirectXMeshPainter;
class DirectXTextPainter;

class DirectXPainter : public AbstractPainter
{
public:
    DirectXPainter();
    void paint(DrawingContext* context) override;

    DirectXMeshPainter* getMeshPainter() const;
    DirectXTextPainter* getTextPainter() const;

private:
    std::unique_ptr<DirectXMeshPainter> mMeshPainter;
    std::unique_ptr<DirectXTextPainter> mTextPainter;
};